package com.example.tests;

import java.util.concurrent.TimeUnit;
import org.junit.*;
import static org.junit.Assert.*;
import org.openqa.selenium.*;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.support.ui.Select;

public class BuildFormsTestCase {
	private WebDriver driver;
	private boolean acceptNextAlert = true;
	private StringBuffer verificationErrors = new StringBuffer();

	@Before
	public void setUp() throws Exception {
		driver = new FirefoxDriver();
		driver.manage().timeouts().implicitlyWait(30, TimeUnit.SECONDS);
	}

	@Test
	public void testBuildFormsTestCase() throws Exception {
		driver.get("http://localhost:8080/Web_Project_1/seleniumTest.jsp");
		driver.findElement(By.linkText("Forms Demo")).click();
		System.out.println("going to write in text boxes");
		driver.findElement(By.name("FirstName")).clear();
		driver.findElement(By.name("FirstName")).sendKeys("Hermione");
		driver.findElement(By.name("LastName")).clear();
		driver.findElement(By.name("LastName")).sendKeys("");
		driver.findElement(By.name("LastName")).sendKeys("Gran");
		driver.findElement(By.name("LastName")).sendKeys("ger");
		System.out.println("going to check boxes");
		if (!driver.findElement(By.xpath("//input[@value='Bike']"))
				.isSelected()) {
			driver.findElement(By.xpath("//input[@value='Bike']")).click();
		}
		;
		if (driver.findElement(By.xpath("//input[@value='Bike']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Bike']")).click();
		}
		;
		System.out.println("Going to click on I have a bike again");
		if (driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Car']")).click();
		}
		;
		if (!driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Car']")).click();
		}
		;
		if (driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Car']")).click();
		}
		;
		if (!driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Car']")).click();
		}
		;
		if (driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Car']")).click();
		}
		;
		if (!driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
			driver.findElement(By.xpath("//input[@value='Car']")).click();
		}
		;
		System.out.println("going to select dropdown");
		new Select(driver.findElement(By.xpath("//select[@name='selectBox1']")))
				.selectByVisibleText("Audi");
		System.out.println("going to radio buttons");
		driver.findElement(By.xpath("(//input[@name='gender'])[2]")).click();
		driver.findElement(By.xpath("//input[@name='gender'][1]")).click();
		driver.findElement(By.xpath("(//input[@name='gender'])[2]")).click();
		driver.findElement(By.xpath("//input[@value='Submit']")).click();
		driver.get("http://www.google.com");
	}

	@After
	public void tearDown() throws Exception {
		driver.quit();
		String verificationErrorString = verificationErrors.toString();
		if (!"".equals(verificationErrorString)) {
			fail(verificationErrorString);
		}
	}

	private boolean isElementPresent(By by) {
		try {
			driver.findElement(by);
			return true;
		} catch (NoSuchElementException e) {
			return false;
		}
	}

	private boolean isAlertPresent() {
		try {
			driver.switchTo().alert();
			return true;
		} catch (NoAlertPresentException e) {
			return false;
		}
	}

	private String closeAlertAndGetItsText() {
		try {
			Alert alert = driver.switchTo().alert();
			String alertText = alert.getText();
			if (acceptNextAlert) {
				alert.accept();
			} else {
				alert.dismiss();
			}
			return alertText;
		} finally {
			acceptNextAlert = true;
		}
	}
}
