package com.example.tests;

import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.support.ui.Select;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Test;

import static org.testng.Assert.*;  //used for assertions

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;

import java.util.concurrent.TimeUnit;

public class BuildFormsTestNG {
	private WebDriver driver;
	String verificationErrorString = ""; //used to set up any verification errors
	
	@BeforeTest
	  public void setUp() throws Exception {
	    driver = new FirefoxDriver();
	    driver.manage().timeouts().implicitlyWait(30, TimeUnit.SECONDS);
	  }
	
	@Test 
	public void testBuildFormsTestNG() throws Exception {
		driver.get("http://localhost:8080/Web_Project_1/seleniumTest.jsp");
	    driver.findElement(By.linkText("Forms Demo")).click();
	    System.out.println("going to write in text boxes");
	    driver.findElement(By.name("FirstName")).clear();
	    driver.findElement(By.name("FirstName")).sendKeys("Hermione");
	    driver.findElement(By.name("LastName")).clear();
	    driver.findElement(By.name("LastName")).sendKeys("");
	    driver.findElement(By.name("LastName")).sendKeys("Gran");
	    driver.findElement(By.name("LastName")).sendKeys("ger");
	    System.out.println("going to check boxes");
	    if (!driver.findElement(By.xpath("//input[@value='Bike']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Bike']")).click();
	    };
	    if (driver.findElement(By.xpath("//input[@value='Bike']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Bike']")).click();
	    };
	    System.out.println("Going to click on I have a bike again");
	    if (driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Car']")).click();
	    };
	    if (!driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Car']")).click();
	    };
	    if (driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Car']")).click();
	    };
	    if (!driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Car']")).click();
	    };
	    if (driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Car']")).click();
	    };
	    if (!driver.findElement(By.xpath("//input[@value='Car']")).isSelected()) {
	      driver.findElement(By.xpath("//input[@value='Car']")).click();
	    };
	    System.out.println("going to select dropdown");
	    new Select(driver.findElement(By.xpath("//select[@name='selectBox1']"))).selectByVisibleText("Audi");
	    System.out.println("going to radio buttons");
	    driver.findElement(By.xpath("(//input[@name='gender'])[2]")).click();
	    driver.findElement(By.xpath("//input[@name='gender'][1]")).click();
	    driver.findElement(By.xpath("(//input[@name='gender'])[2]")).click();
	    driver.findElement(By.xpath("//input[@value='Submit']")).click();
	    driver.get("http://www.google.com");
	}
	
	  @AfterTest
	  public void tearDown() throws Exception {
	    driver.quit();
	    if (!"".equals(verificationErrorString)) {
	      fail(verificationErrorString);
	    }
	  }
}
